/*
   _===_ _           _                  ______ _     _             _ _ _
  |  ___| |         | |                 | ___ (_)   | |           (_) | |
  | |__ | | ___  ___| |_ _ __ ___ ______| |_/ /_  __| | ___  _   _ _| | | ___ _   _ _ __
  |  __|| |/ _ \/ __| __| '__/ _ \______| ___ \ |/ _` |/ _ \| | | | | | |/ _ \ | | | '__|
  | |___| |  __/ (__| |_| | | (_) |     | |_/ / | (_| | (_) | |_| | | | |  __/ |_| | |
  \____/|_|\___|\___|\__|_|  \___/      \____/|_|\__,_|\___/ \__,_|_|_|_|\___|\__,_|_|
*/

/* 
 * File:   charge_Fictive_main.c
 * Auteur: lectro-Bidouilleur
 *
 * Cr le 01.09.2015
 */

// INSTRUCTIONS AU COMPILATEUR
#define _XTAL_FREQ 1000000 //The speed of your internal(or)external oscillator
#define USE_OR_MASKS   // Permet d'utiliser les masques OR prdfinis dans les fichiers header,
#define VRAI 1          // de la faon  MASK1 | MASK2 | MASK3...
#define FAUX 0
#define longueur_commande_rx 7          // inclue le \0  la find de la chane de caractres
#define  DEPART_CYCLE_SERVICE 614
#include <xc.h>       
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pwm.h>
#include <timers.h>
#include <adc.h>
#include <usart.h>
#include <pic18f1220.h>

// CONFIGURATION BYTES
// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

// CONFIG1H
#pragma config OSC = INTIO2     // Oscillator Selection bits (Internal RC oscillator, port function on RA6 and port function on RA7)
#pragma config FSCM = OFF       // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal External Switchover bit (Internal External Switchover mode disabled)
// CONFIG2L
#pragma config PWRT = OFF       // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOR = OFF        // Brown-out Reset Enable bit (Brown-out Reset disabled)
// BORV = No Setting
// CONFIG2H
#pragma config WDT = OFF        // Watchdog Timer Enable bit (WDT disabled (control is placed on the SWDTEN bit))
#pragma config WDTPS = 32768    // Watchdog Timer Postscale Select bits (1:32768)
// CONFIG3H
#pragma config MCLRE = OFF      // MCLR Pin Enable bit (RA5 input pin enabled, MCLR disabled)
// CONFIG4L
#pragma config STVR = ON        // Stack Full/Underflow Reset Enable bit (Stack full/underflow will cause Reset)
#pragma config LVP = ON         // Low-Voltage ICSP Enable bit (Low-Voltage ICSP enabled)
// CONFIG5L
#pragma config CP0 = OFF        // Code Protection bit (Block 0 (00200-0007FFh) not code-protected)
#pragma config CP1 = OFF        // Code Protection bit (Block 1 (000800-000FFFh) not code-protected)
// CONFIG5H
#pragma config CPB = OFF        // Boot Block Code Protection bit (Boot Block (000000-0001FFh) not code-protected)
#pragma config CPD = OFF        // Data EEPROM Code Protection bit (Data EEPROM not code-protected)
// CONFIG6L
#pragma config WRT0 = OFF       // Write Protection bit (Block 0 (00200-0007FFh) not write-protected)
#pragma config WRT1 = OFF       // Write Protection bit (Block 1 (000800-000FFFh) not write-protected)
// CONFIG6H
#pragma config WRTC = OFF       // Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) not write-protected)
#pragma config WRTB = OFF       // Boot Block Write Protection bit (Boot Block (000000-0001FFh) not write-protected)
#pragma config WRTD = OFF       // Data EEPROM Write Protection bit (Data EEPROM not write-protected)
// CONFIG7L
#pragma config EBTR0 = OFF      // Table Read Protection bit (Block 0 (00200-0007FFh) not protected from table reads executed in other blocks)
#pragma config EBTR1 = OFF      // Table Read Protection bit (Block 1 (000800-000FFFh) not protected from table reads executed in other blocks)
// CONFIG7H
#pragma config EBTRB = OFF      // Boot Block Table Read Protection bit (Boot Block (000000-0001FFh) not protected from table reads executed in other blocks)

// Variables Globales
unsigned char Tampon_Rx[longueur_commande_rx];
unsigned char Index_Tampon_Rx = 0;
unsigned char Commande_Rx[longueur_commande_rx];
bit Commande_Rx_Prete = FAUX;
bit decharge_active = FAUX;
bit alarme_active = FAUX;
unsigned int Ibatt=0;           // Le courant mesur de la batterie
unsigned int Ibatt_cible=0;     // Le courant cible  atteindre
unsigned int Vbatt=0;           // La tension de la rsistance, ct batterie
unsigned int Vmosfet=0;          // La tension de la rsistance, ct MOSFET
unsigned int Vbatt_Arret=0;      // La tension d'arrt automatique
unsigned int cycle_service=0;   // Le cycle de service
unsigned int ADCResult=0;       // Le rsultat de la conversion ADC
int param_num = 0;
unsigned char i=0;
char chaine_temp[5];
char Tampon_Tx[25];

// La routine d'interruption
void interrupt low_priority Routine_Interruption()   
{
    if(PIR1bits.RCIF == 1) // Vrifier si l'interruption est cause par la rception sur le USART
    {  // oui
        PIE1bits.RCIE  = 0;  // Bloquer les interruptions du USART Rx
        Tampon_Rx[Index_Tampon_Rx] = ReadUSART();   // Lire le caractre reu du rgistre Rx et le mettre dans la mmoire tempon, case suivante
        if (Tampon_Rx[Index_Tampon_Rx] == '\n')     // Caractre reu LF (ASCII 10) ?
        {    // oui
            if ((Index_Tampon_Rx == longueur_commande_rx - 2))      //  LF positionn au bon endroit dans la commande reue?
            {   // Oui
                strcpy(Commande_Rx,Tampon_Rx);      // Sauvegarder la mmoire tampon dans la mmoire de commande reue
                Commande_Rx_Prete = VRAI;           // Lever le drapeau d'une commande reue prte  tre traite
            }
            Index_Tampon_Rx = 0;    // Rinitialiser l'index.
        }
        else if (Index_Tampon_Rx == longueur_commande_rx - 2) Index_Tampon_Rx = 0;      // Sinon, Si la mmoire tempon est pleine, rinitialiser l'index.
        else Index_Tampon_Rx++;     // Sinon, incrmenter l'index de la mmoire tampon Rx.
        PIR1bits.RCIF = 0;      // Effacer l'indicateur d'interruption
        PIE1bits.RCIE  = 1;     // Permettre  nouveau les interruptions de la part du Rx USART
    }
}

void main()
{
    // Configurer l'oscillateur interne  1MHz
    OSCCON = 0b01000010;
    Index_Tampon_Rx = 0;        // Initialiser l'index de la mmoire tampon.
     
    //----Initialiser le USART  2400 bps----
    PORTBbits.RB1 = 1;      // La broche USART Tx configure en entre; le USART va la re-configurer correctement
    PORTBbits.RB4 = 1;      // La broche USART Rx configure en entre
    ADCON1 = ADCON1 | 0b01100000;       // Les broches du USART configures en E/S, pas en entre analogique
    #define UART1Config (USART_TX_INT_OFF | USART_RX_INT_ON | USART_ASYNCH_MODE | USART_EIGHT_BIT | USART_CONT_RX | USART_BRGH_HIGH)
    #define baud 25
    OpenUSART(UART1Config,baud);

    // Configurer les rgistres d'interruption pour le USART
    PIR1bits.RCIF = 0;      // Effacer l'indicateur d'interruption
    IPR1bits.RCIP = 0;      // Basse priorit
    PIE1bits.RCIE = 1;      // Permettre les interruptions venant du USART Rx
    INTCONbits.PEIE = 1;    // Permettre les interruptions de priphriques (le USART est un priphrique)
    INTCONbits.GIE = 1;     // Permettre les interruptions

    //----Initialiser l'ADC----
    #define adc_config1 (ADC_FOSC_2 | ADC_RIGHT_JUST | ADC_2_TAD)    // La conversion prends 100us
    #define adc_config2 (ADC_CH0 | ADC_INT_OFF | ADC_REF_VDD_VSS)
    #define adc_portconfig ADC_2ANA
    OpenADC(adc_config1,adc_config2,adc_portconfig);

//----Configurer le PWM ----
    #define config_timer2 (TIMER_INT_OFF|T2_PS_1_1)
    OpenTimer2(config_timer2);
    #define periode_pwm  0xFF
    OpenPWM1(periode_pwm);            //Configurer la sortie du PWM et initialiser sa priode
    SetDCPWM1(cycle_service);         // Mettre le cycle de service  0% pour le dpart

//----configurer la sortie du PWM----
    #define config_sortie SINGLE_OUT    // sortie unique
    #define mode_sortie PWM_MODE_1   // sortie active en niveau haut
    SetOutputPWM1(config_sortie, mode_sortie);    

    //-----Boucle Principale-----
    while(1)    // Boucle Principale
    {
        SetDCPWM1(cycle_service);       // Assigner la valeur lue de l'ADC au cycle de service du PWM.
        __delay_ms(10);                 // Dlai pour stabiliser la sortie du PWM une fois filtre.

        //---Mersurer la tension de la batterie
        SetChanADC(ADC_CH0);    // Slectionner l'entre analogique AN0
        ConvertADC();           // Lancer la conversion analogique-numrique
        while(BusyADC());       // Attendre que l'ADC ait termin la conversion
        Vbatt = ReadADC();      // Lire le rsultat de la conversion

        //---Mersurer la tension du MOSFET
        SetChanADC(ADC_CH1);    // Slectionner l'entre analogique AN1
        ConvertADC();           // Lancer la conversion analogique-numrique
        while(BusyADC());       // Attendre que l'ADC ait termin la conversion
        Vmosfet = ReadADC();     // Lire le rsultat de la conversion
 
        //---Calculer et excuter la correction de courant
        if (decharge_active == VRAI)        // Cycle de dcharge activ?
        {   // Oui
            if (Vbatt >= Vmosfet)    // Condition normale si le courant est de dcharge... Si tension de batterie > tension Mosfet
            {   // oui
                Ibatt = Vbatt - Vmosfet;         // Simple soustraction des tensions pour driver le courant. Tout est fonction des constantes connues.
                if (Ibatt > Ibatt_cible)        // Si le courant est trop fort compar  la cible
                {   //oui
                    if (cycle_service > 0) cycle_service--;     // Diminuer le courant par un saut unique du cycle de service du PWM
                }
                else if (Ibatt < Ibatt_cible)   // Sinon, si le courant est insuffisant compar  la cible
                {   //oui
                    if (cycle_service < 1023) cycle_service++;  // Augmenter le courant par un saut unique du cycle de service du PWM
                    else 
                    {    
                        alarme_active = VRAI;      // Condition de cycle de service  la limite suprieure. Lever l'indicateur d'alarme
                        cycle_service = 0;         // Couper la sortie du PWM.
                        decharge_active = FAUX;    // teindre le cycle de dcharge
                    }
                }
                if (Vbatt <= Vbatt_Arret)      // Tension de batterie a atteint limite d'arrt automatique?
                {   //oui
                    cycle_service = 0;         // Couper la sortie du PWM.
                    decharge_active = FAUX;    // teindre le cycle de dcharge
                }
            }
            else if (Vbatt < (Vmosfet - 10))      // Condition anormale. Le "- 10" est la marge d'erreur consdrant le bruit
            {   // oui
                alarme_active = VRAI;      // Lever l'indicateur d'alarme
                cycle_service = 0;         // Couper la sortie du PWM.
                decharge_active = FAUX;    // teindre le cycle de dcharge
            }
        }

        // Traitement de commandes reues sur le port srie
        if (Commande_Rx_Prete == VRAI)      // Commande Reue prte  tre traite?
        {   // Oui
            Commande_Rx_Prete = FAUX;       // Abaisser l'indicateur de commande Rx prte

            // Envoi du OK de confirmation de rception de commande
 //           Tampon_Tx[0] = '\0';        // Ajouter le code NULL au dbut de la chane de caractres
 //           strcat(Tampon_Tx, "ok");    // Construction de la chane de caractres
 //           putsUSART(Tampon_Tx);       // Envoyer la chane de caractres

            // Extraction de la valeur numrique de la commande
            i = 0;          // initialieser le compteur d'itration
            while (i < 4)   // tant que l'itration n'est pas  4
            {
                chaine_temp[i] = Commande_Rx[i+1];      // Copier le caractre suivant dans la chane de caractres temporaire
                i++;    // incrmenter le compteur d'itration
            }
            chaine_temp[i] = '\0';   // Ajouter le code NULL  la fin de la chane
            param_num = atoi(chaine_temp);  // Convertir la chane de caractres en valeur numrique

            // Changement de courant cible
            if (Commande_Rx[0] == 'C')      // Commande de changement de courant cible reue?
            {   // Oui
                Ibatt_cible = param_num;    // Tranfrer la valeur numrique dans le courant cible
            }

            // Changement de tension d'arret automatique
            if (Commande_Rx[0] == 'A')      // Commande de changement de tension d'arrt automatique reue?
            {   // Oui
                Vbatt_Arret = param_num;    // Tranfrer la valeur numrique dans la tension d'arrt automatique
            }
            // Dmarrage du cylce de dcharge
            if (Commande_Rx[0] == 'G')      // Commande de dmarrage du cylce de dcharge reue?
            {   // Oui
                decharge_active = VRAI;     // Dmarrer un cycle de dcharge
                cycle_service = DEPART_CYCLE_SERVICE;        // On dmarre le PWM  60% de cycle de service.
                alarme_active = FAUX;       // Effacer tout indicateur d'alarme
            }
            // Arrt de la dcharge
            if (Commande_Rx[0] == 'S')       // Commande d'arrt du cylce de dcharge reue?
            {   // Oui
                decharge_active = FAUX;      // Stopper le cycle de dcharge
                cycle_service = 0;          // Mettre le cycle se service  0
                Ibatt = 0;
            }
            if (Commande_Rx[0] == 'D')      // Commande de effacer l'indicateur d'alarme?
            {   // Oui
                alarme_active = FAUX;       // Effacer tout indicateur d'alarme
            }
            // Demande de l'tat du systme
            if (Commande_Rx[0] == 'E')      // Commande pour l'obtention de l'tat du systme?
            {
                Tampon_Tx[0] = '\0';        // Ajouter le code NULL au dbut de la chane de caractres
                strcat(Tampon_Tx, "e,");    // Construction de la chane de caractres de l'tat du systme
                strcat(Tampon_Tx, utoa(chaine_temp,decharge_active,10));    // ajouter l'tat de la dcharge
                strcat(Tampon_Tx,",");
                strcat(Tampon_Tx, utoa(chaine_temp,alarme_active,10));      // ajouter l'tat de l'alarme
                strcat(Tampon_Tx,",");
                strcat(Tampon_Tx, utoa(chaine_temp,Ibatt,10));              // ajouter le courant de batterie
                strcat(Tampon_Tx,",");
                strcat(Tampon_Tx, utoa(chaine_temp,Vbatt,10));              // ajouter la tension de batterie
                strcat(Tampon_Tx,",");
                strcat(Tampon_Tx, utoa(chaine_temp,cycle_service,10));      // ajouter la valeur du cycle de service
                strcat(Tampon_Tx,",");
                strcat(Tampon_Tx, utoa(chaine_temp,Ibatt_cible,10));        // ajouter le courant cible de batterie
                putsUSART(Tampon_Tx);                                       // Envoyer la chane de caractres
            }
        }
    }

}

//              TRISB = TRISB & 0b11111011;
//               RB2 = 1;
//               __delay_ms(1);
//               RB2 =0;

